<?php
//
//	System specific parameters...
//	KB4FXC 02/2018
//
//	NOTE: DO NOT MODIFY!
//	THIS FILE WILL BE OVERWRITTEN BY PACKAGE UPDATES!
//
// Title in header when logged in
$TITLE_LOGGED = "Supermon 7+ (HV) AllStar-SvxLink Manager";
//
// Title in header when not logged in
$TITLE_NOT_LOGGED = "Supermon 7+ (HV) AllStar-SvxLink Monitor";
//
// Webserver access log
$WEB_ACCESS_LOG = "/var/log/lighttpd/access_log";
//
// Webserver error log
$WEB_ERROR_LOG = "/var/log/lighttpd/error.log";
//
// Asterisk message log
$ASTERISK_LOG = "/var/log/asterisk/messages";
//
// AllStar allmon database
$ASTDB_TXT = "/var/log/asterisk/astdb.txt";
//
// AllStar rpt_extnodes file --- not present in DNS mode.
$EXTNODES = "/tmp/rpt_extnodes";
//
// AllStar Echolink database dump
$ECHO_DB = "/tmp/echolink.db.gz";
//
// Private AllStar nodelist
$PRIVATENODES = "/etc/asterisk/local/privatenodes.txt";
//
//	IRLP related...
$IRLP_CALLS = "/tmp/irlpdata.txt.gz";
$IRLP_LOG = "/tmp/svxlink.log";
//
// Cache version number info.
$file = `find /tmp/asterisk_version /run/asterisk.pid /etc/allstar_version -printf "%T@  %p\n" 2>/dev/null | sort -nr | awk '{if (NR == 1) printf ("%s", $2)}'`;
if ($file == "/tmp/asterisk_version")
        $version= `cat /tmp/asterisk_version`;
else
        $version = `export TERM=vt100; asterisk -rx "core show version" |awk '{print $2}' | tee /tmp/asterisk_version`;

$version="Asterisk $version";
//echo "<p>$file, $version</p>";
//
// Make sure this is hamvoip "Vx.xrc" code
$pattern="/ [0-9].[0-9]rc[0-9]/";
if (preg_match($pattern, $version, $match)) {
	$system_type = "hamvoip";
} else {
	// Add other types if needed here
	// $system_type="";
	$system_type = "spotnik-asl";
}
//
//	Paths to various programs called from php...
$ASTERISK =	"/usr/bin/asterisk";
$AWK =		"/usr/bin/awk";
$CAT =		"/usr/bin/cat";
$CUT =		"/usr/bin/cut";
$DATE =		"/usr/bin/date";
$EGREP =	"/usr/bin/egrep";
$GREP =		"/usr/bin/grep";
$HEAD =		"/usr/bin/head";
$HOSTNAME =	"/usr/bin/hostname";
$IFCONFIG =	"/usr/sbin/ifconfig";
$JOURNALCTL =	"/usr/bin/journalctl";
$MBUFFER =	"/usr/local/bin/mbuffer";
$SED =		"/usr/bin/sed";
$SUDO =		"export TERM=vt100 && /usr/bin/sudo";
$TAIL =		"/usr/bin/tail";
$UPTIME =	"/usr/bin/uptime";
$WGET =		"/usr/bin/wget";
$ZCAT =		"/usr/bin/zcat";

if (file_exists($IRLP_LOG))
	$IRLPLOG = true;
else
	$IRLPLOG = false;

if (file_exists($IRLP_CALLS))
	$IRLP = true;
else
	$IRLP = false;

if (file_exists($EXTNODES))
	$EXTN = true;
else
	$EXTN = false;
?>
